"use strict";
/* eslint-env jasmine */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Api_1 = require("../lib/Api");
var ValidationError_1 = require("../lib/ValidationError");
var FakeApi = /** @class */ (function (_super) {
    __extends(FakeApi, _super);
    function FakeApi() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.baseUrl = '/fake_api_server.php';
        return _this;
    }
    FakeApi.prototype.testOnlyMockFetchFunction = function (fakeFetchFunction) {
        this.fetchFunction = fakeFetchFunction;
    };
    return FakeApi;
}(Api_1.Api));
describe('Api', function () {
    describe('call', function () {
        it('returns API response', function () { return __awaiter(void 0, void 0, void 0, function () {
            var api, fakeFetch, responseJson, fakeUnfetchResponse, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = new FakeApi();
                        fakeFetch = jest.fn();
                        api.testOnlyMockFetchFunction(fakeFetch);
                        responseJson = ['test', '1234'];
                        fakeUnfetchResponse = {
                            json: function () { return Promise.resolve(responseJson); },
                            ok: true,
                            text: function () { return Promise.resolve(JSON.stringify(responseJson)); },
                        };
                        fakeFetch.mockReturnValue(Promise.resolve(fakeUnfetchResponse));
                        return [4 /*yield*/, api.call('fake1', 'test-1234')];
                    case 1:
                        response = _a.sent();
                        expect(fakeFetch).toHaveBeenCalledWith('/fake_api_server.php/fake1', {
                            body: '"test-1234"',
                            headers: { 'Content-Type': 'application/json' },
                            method: 'POST',
                        });
                        expect(response).toEqual(['test', '1234']);
                        return [2 /*return*/];
                }
            });
        }); });
        it('returns API errors', function () { return __awaiter(void 0, void 0, void 0, function () {
            var api, fakeFetch, responseJson, fakeUnfetchResponse, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = new FakeApi();
                        fakeFetch = jest.fn();
                        api.testOnlyMockFetchFunction(fakeFetch);
                        responseJson = {
                            error: {
                                type: 'ValidationError',
                                validationErrors: ['Not gonna do that :/'],
                            },
                            message: 'Validation Error',
                        };
                        fakeUnfetchResponse = {
                            json: function () { return Promise.resolve(responseJson); },
                            ok: false,
                            text: function () { return Promise.resolve(JSON.stringify(responseJson)); },
                        };
                        fakeFetch.mockReturnValue(Promise.resolve(fakeUnfetchResponse));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, api.call('fake1', 'test-1234')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        if (!(err_1 instanceof Error)) {
                            throw new Error("Error was not an error: " + err_1);
                        }
                        expect(fakeFetch).toHaveBeenCalledWith('/fake_api_server.php/fake1', {
                            body: '"test-1234"',
                            headers: { 'Content-Type': 'application/json' },
                            method: 'POST',
                        });
                        expect(err_1.message).toBe('Validation Error');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('handles missing error', function () { return __awaiter(void 0, void 0, void 0, function () {
            var api, fakeFetch, responseJson, fakeUnfetchResponse, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = new FakeApi();
                        fakeFetch = jest.fn();
                        api.testOnlyMockFetchFunction(fakeFetch);
                        responseJson = {};
                        fakeUnfetchResponse = {
                            json: function () { return Promise.resolve(responseJson); },
                            ok: false,
                            text: function () { return Promise.resolve(JSON.stringify(responseJson)); },
                        };
                        fakeFetch.mockReturnValue(Promise.resolve(fakeUnfetchResponse));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, api.call('fake1', 'test-1234')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_2 = _a.sent();
                        if (!(err_2 instanceof Error)) {
                            throw new Error("Error was not an error: " + err_2);
                        }
                        expect(fakeFetch).toHaveBeenCalledWith('/fake_api_server.php/fake1', {
                            body: '"test-1234"',
                            headers: { 'Content-Type': 'application/json' },
                            method: 'POST',
                        });
                        expect(err_2.message).toBe('Ein Fehler ist aufgetreten. Bitte später nochmals versuchen.');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('handles connection errors', function () { return __awaiter(void 0, void 0, void 0, function () {
            var api, fakeFetch, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        api = new FakeApi();
                        fakeFetch = jest.fn();
                        api.testOnlyMockFetchFunction(fakeFetch);
                        fakeFetch.mockReturnValue(Promise.reject(new Error('test-error')));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, api.call('fake1', 'test-1234')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_3 = _a.sent();
                        if (!(err_3 instanceof Error)) {
                            throw new Error("Error was not an error: " + err_3);
                        }
                        expect(err_3.message).toBe('test-error');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getValidationErrorFromResponseText', function () {
        var api;
        beforeEach(function () {
            api = new FakeApi();
        });
        it('works when there is no reponse text', function () {
            expect(api.getValidationErrorFromResponseText(undefined)).toEqual(undefined);
            expect(api.getValidationErrorFromResponseText('')).toEqual(undefined);
        });
        it('works for invalid JSON', function () {
            expect(api.getValidationErrorFromResponseText('invalid json')).toEqual(undefined);
        });
        it('works for non-ValidationError JSON', function () {
            expect(api.getValidationErrorFromResponseText(JSON.stringify(null))).toEqual(undefined);
            expect(api.getValidationErrorFromResponseText(JSON.stringify({}))).toEqual(undefined);
            expect(api.getValidationErrorFromResponseText(JSON.stringify({
                error: {},
            }))).toEqual(undefined);
            expect(api.getValidationErrorFromResponseText(JSON.stringify({
                error: { type: 'invalid' },
            }))).toEqual(undefined);
        });
        it('works without message', function () {
            expect(function () { return api.getValidationErrorFromResponseText(JSON.stringify({
                error: {
                    type: 'ValidationError',
                    validationErrors: ['test'],
                },
            })); }).toThrow();
        });
        it('works without validation errors', function () {
            expect(function () { return api.getValidationErrorFromResponseText(JSON.stringify({
                error: { type: 'ValidationError' },
                message: 'test',
            })); }).toThrow();
        });
        it('works ValidationError JSON', function () {
            expect(api.getValidationErrorFromResponseText(JSON.stringify({
                error: {
                    type: 'ValidationError',
                    validationErrors: { 'field1': ['testError'] },
                },
                message: 'testMessage',
            }))).toEqual(new ValidationError_1.ValidationError('testMessage', { 'field1': ['testError'] }));
        });
    });
    describe('mergeValidationErrors', function () {
        var api;
        beforeEach(function () {
            api = new FakeApi();
        });
        var validationError1 = new ValidationError_1.ValidationError('testMessage1', { 'field1': ['testError1'] });
        var validationError2 = new ValidationError_1.ValidationError('testMessage2', { 'field2': ['testError2'] });
        var validationError3 = new ValidationError_1.ValidationError('', { 'field3': ['testError3'] });
        var nullValidationError = new ValidationError_1.ValidationError('', {});
        function expectValidationErrorsEqual(expectError, toEqualError) {
            expect(expectError.message).toEqual(toEqualError.message);
            expect(expectError.getErrorsByField()).toEqual(toEqualError.getErrorsByField());
        }
        it('merges empty list of errors', function () {
            expect(api.mergeValidationErrors([])).toEqual(nullValidationError);
        });
        it('returns the validation error when merging just one', function () {
            var mergedError1 = api.mergeValidationErrors([validationError1]);
            var mergedError2 = api.mergeValidationErrors([validationError2]);
            var mergedError3 = api.mergeValidationErrors([validationError3]);
            expectValidationErrorsEqual(mergedError1, validationError1);
            expectValidationErrorsEqual(mergedError2, validationError2);
            expectValidationErrorsEqual(mergedError3, validationError3);
        });
        it('merges two validation errors', function () {
            var mergedError = api.mergeValidationErrors([
                validationError1,
                validationError2,
            ]);
            var expectedError = new ValidationError_1.ValidationError('testMessage1\ntestMessage2', {
                'field1': ['testError1'],
                'field2': ['testError2'],
            });
            expectValidationErrorsEqual(mergedError, expectedError);
        });
        it('merges three validation errors', function () {
            var mergedError = api.mergeValidationErrors([
                validationError1,
                validationError2,
                validationError3,
            ]);
            var expectedError = new ValidationError_1.ValidationError('testMessage1\ntestMessage2', {
                'field1': ['testError1'],
                'field2': ['testError2'],
                'field3': ['testError3'],
            });
            expectValidationErrorsEqual(mergedError, expectedError);
        });
        it('concatenates errors on the same field', function () {
            var mergedError = api.mergeValidationErrors([
                validationError1,
                validationError1,
            ]);
            var expectedError = new ValidationError_1.ValidationError('testMessage1\ntestMessage1', {
                // TODO: This should be:
                // 'field1': ['testError1', 'testError1'],
                'field1': ['testError1'],
            });
            expectValidationErrorsEqual(mergedError, expectedError);
        });
    });
});
//# sourceMappingURL=Api.test.js.map