"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.submitSPTransportConnectionForm = exports.submitSqrtForm = exports.submitDivideForm = void 0;
var ExampleApi_1 = require("./ExampleApi");
var exampleApi = new ExampleApi_1.ExampleApi();
function submitDivideForm(form) {
    var dividendField = form.elements.namedItem('dividend');
    var divisorField = form.elements.namedItem('divisor');
    var resultField = form.elements.namedItem('result');
    exampleApi.call('divideNumbers', {
        dividend: Number(dividendField && 'value' in dividendField ? dividendField.value : null),
        divisor: Number(divisorField && 'value' in divisorField ? divisorField.value : null),
    }).then(function (result) {
        if (resultField && 'value' in resultField) {
            resultField.value = "The result is " + result;
        }
    });
    return false;
}
exports.submitDivideForm = submitDivideForm;
function submitSqrtForm(form) {
    var inputField = form.elements.namedItem('input');
    var resultField = form.elements.namedItem('result');
    exampleApi.call('squareRoot', Number(inputField && 'value' in inputField ? inputField.value : null)).then(function (result) {
        if (resultField && 'value' in resultField) {
            resultField.value = "The result is " + result;
        }
    });
    return false;
}
exports.submitSqrtForm = submitSqrtForm;
function submitSPTransportConnectionForm(form) {
    var fromField = form.elements.namedItem('from');
    var toField = form.elements.namedItem('to');
    var viaField = form.elements.namedItem('via');
    var dateField = form.elements.namedItem('date');
    var timeField = form.elements.namedItem('time');
    var isArrivalTimeField = form.elements.namedItem('isArrivalTime');
    var resultField = form.elements.namedItem('result');
    exampleApi.call('searchSwissPublicTransportConnection', {
        from: fromField && 'value' in fromField ? fromField.value : '',
        to: toField && 'value' in toField ? toField.value : '',
        via: viaField && 'value' in viaField && viaField.value ? [viaField.value] : [],
        date: dateField && 'value' in dateField ? dateField.value : '',
        time: timeField && 'value' in timeField ? timeField.value : '',
        isArrivalTime: isArrivalTimeField && 'value' in isArrivalTimeField ? isArrivalTimeField.value === '1' : false,
    }).then(function (result) {
        if (resultField && 'value' in resultField) {
            resultField.value = "The result is " + result;
        }
    });
    return false;
}
exports.submitSPTransportConnectionForm = submitSPTransportConnectionForm;
//# sourceMappingURL=index.js.map