"use strict";
/* eslint-env jasmine */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var path_1 = __importDefault(require("path"));
var http_1 = __importDefault(require("http"));
var ExampleApi_1 = require("../../example/web/ExampleApi");
var ValidationError_1 = require("../../client/lib/ValidationError");
describe('divideNumbers', function () {
    var server;
    beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        var examplePath, serverUrl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    examplePath = path_1.default.resolve(__dirname, '..', '..', 'example');
                    serverUrl = 'http://127.0.0.1:30270';
                    server = (0, child_process_1.spawn)('./run.sh', [], {
                        detached: true,
                        shell: true,
                        cwd: examplePath,
                    });
                    return [4 /*yield*/, waitFor(1000)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, getHttpStatusCode(serverUrl)];
                case 2:
                    if ((_a.sent()) === 200) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, waitFor(2000)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, getHttpStatusCode(serverUrl)];
                case 4:
                    if ((_a.sent()) === 200) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, waitFor(4000)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, getHttpStatusCode(serverUrl)];
                case 6:
                    if ((_a.sent()) === 200) {
                        return [2 /*return*/];
                    }
                    throw new Error('Timeout starting example server');
            }
        });
    }); });
    afterAll(function () {
        if (server.pid) {
            process.kill(-server.pid);
        }
        else {
            server.kill();
        }
    });
    it('divideNumbers works end to end', function () { return __awaiter(void 0, void 0, void 0, function () {
        var exampleApi, result1, result2, result3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    exampleApi = new ExampleApi_1.ExampleApi();
                    return [4 /*yield*/, exampleApi.call('divideNumbers', { dividend: 6, divisor: 3 })];
                case 1:
                    result1 = _a.sent();
                    expect(result1).toEqual(2);
                    return [4 /*yield*/, exampleApi.call('divideNumbers', { dividend: 6, divisor: 12 })];
                case 2:
                    result2 = _a.sent();
                    expect(result2).toEqual(0.5);
                    return [4 /*yield*/, exampleApi.call('divideNumbers', { dividend: 4, divisor: 3 })];
                case 3:
                    result3 = _a.sent();
                    expect(result3).toEqual(1.3333333333333333);
                    return [2 /*return*/];
            }
        });
    }); });
    it('divideNumbers works end to end in error case', function () { return __awaiter(void 0, void 0, void 0, function () {
        var exampleApi, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    exampleApi = new ExampleApi_1.ExampleApi();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, exampleApi.call('divideNumbers', { dividend: 6, divisor: 0 })];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    if (!(err_1 instanceof ValidationError_1.ValidationError)) {
                        throw new Error('ValidationError expected');
                    }
                    expect(err_1.message).toEqual('Fehlerhafte Eingabe.');
                    expect(err_1.getErrorsByField()).toEqual({
                        'divisor': ['Cannot divide by zero.'],
                    });
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    it('squareRoot works end to end', function () { return __awaiter(void 0, void 0, void 0, function () {
        var exampleApi, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    exampleApi = new ExampleApi_1.ExampleApi();
                    return [4 /*yield*/, exampleApi.call('squareRoot', 16)];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual(4);
                    return [2 /*return*/];
            }
        });
    }); });
    it('squareRoot works end to end in error case', function () { return __awaiter(void 0, void 0, void 0, function () {
        var exampleApi, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    exampleApi = new ExampleApi_1.ExampleApi();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, exampleApi.call('squareRoot', -1)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_2 = _a.sent();
                    if (!(err_2 instanceof ValidationError_1.ValidationError)) {
                        throw new Error('ValidationError expected');
                    }
                    expect(err_2.message).toEqual('Fehlerhafte Eingabe.');
                    expect(err_2.getErrorsByField()).toEqual({
                        '.': ['Wert darf nicht kleiner als 0 sein.'],
                    });
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
});
function getHttpStatusCode(url) {
    return new Promise(function (resolve) {
        var req = http_1.default.request(url, function (res) {
            resolve(res.statusCode);
        });
        req.on('error', function () {
            resolve(0);
        });
        req.end();
    });
}
function waitFor(milliseconds) {
    return new Promise(function (resolve) {
        setTimeout(function () {
            resolve(milliseconds);
        }, milliseconds);
    });
}
//# sourceMappingURL=divideNumbers.test.js.map